// alphas for TMDlib
#include "TMDlib.h"
//using namespace TMDlib; 
using namespace std;

extern int iset, irep, imode ;

double TMDlib::TMDgetLam4( ){

if(iset < 0 ) { 
      cout << " TMDgetLam4: iset is not defined " << endl; 
      return -9999 ;}
   else if ( iset >=101000 && iset < 101200) return 0.25  ;
   else if ( iset >=101201 && iset <= 101320) return 0.2  ;
   else if ( iset ==400001) return 0.3  ;
   else if ( iset ==400002) return 0.35  ;
   else if ( iset ==400003) return 0.35  ;
   else if ( iset ==400004) return 0.35  ;
   else if ( iset ==300001 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;}
   else if ( iset ==300002 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;}
   else if ( iset ==600001) return 0.2  ;
   else { 
      cout << " TMDgetLam4: iset is not defined " << endl; 
      return -9999 ;}
}

int TMDlib::TMDgetNf( ){
if(iset < 0 ) { 
      cout << " TMDgetNf: iset is not defined " << endl; 
      return -9999; }
   else if ( iset >=101200 && iset <= 101320) return 4  ;
   else if ( iset ==300001 ) {
     cout << " No QCD evolution in this fit " << endl;
     return 0 ;}
   else if ( iset ==300002 ) {
     cout << " No QCD evolution in this fit " << endl;
     return 0 ;}
}
int TMDlib::TMDgetOrderAlphaS( ){
if(iset < 0 ) { 
      cout << " TMDgetOrderAlphaS: iset is not defined " << endl; 
      return -9999 ; }
   else if ( iset >=101000 && iset <= 101200) return 1  ;
   else if ( iset >=101200 && iset <= 101320) return 2  ;
   else if ( iset ==300001 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;} 
   else if ( iset ==300002 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;} 
   else if ( iset >=400001 && iset <= 400004) return 1  ;
   else if ( iset >=500001 && iset <= 500001) return 3  ;
   else { 
      cout << " TMDgetOrderAlphaS: iset is not defined " << endl; 
      return -9999 ; }
}

int TMDlib::TMDgetOrderPDF( ){
if(iset < 0 ) { 
      cout << " TMDgetOrderPDF: iset is not defined " << endl; 
      return -9999 ; }
   else if ( iset >=101000 && iset <= 101320) return 1 ;
   else if ( iset ==300001 ) return 0 ;
   else if ( iset ==300002 ) return 0 ;
   else if ( iset >=400001 && iset <= 400004) return 1  ;
   else if ( iset >=500001 && iset <= 500001) return 1  ;
   else if ( iset >=600001 && iset <= 600001) return 1  ;
   else { 
      cout << " TMDgetOrderPDF: iset is not defined " << endl; 
      return -9999 ; }

}

double TMDlib::TMDgetXmin() {
if(iset < 0 ) { 
      cout << " TMDgetXmin: iset is not defined " << endl; 
      return -9999. ; }
   else if ( iset >=101000 && iset <= 101320) return 1.e-6 ;
   else if ( iset ==300001 ) return 0.06 ;
   else if ( iset ==300002 ) return 0.06 ;
   else if ( iset >=400001 && iset <= 400002) return 1.78E-8  ;
   else if ( iset >=400003 && iset <= 400004) return 1.E-7  ;
   else if ( iset >=500001 && iset <= 500001) return 1.E-4  ;
   else if ( iset >=600001 && iset <= 600001) return 1.E-7  ;
   else { 
      cout << " TMDgetXmin: iset is not defined " << endl; 
      return -9999. ; }

}

double TMDlib::TMDgetXmax() {
if(iset < 0 ) { 
      cout << " TMDgetXmax: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset >=101000 && iset <= 101320) return 1. ;
   else if ( iset ==300001 ) return 0.41 ;
   else if ( iset ==300002 ) return 0.41 ;
   else if ( iset >=400001 && iset <= 400004) return 0.01  ;
   else if ( iset >=500001 && iset <= 500001) return 1.0  ;
   else if ( iset >=600001 && iset <= 600001) return 1.0  ;
   else { 
      cout << " TMDgetXmax: iset is not defined " << endl; 
      return -9999.; }

}

double TMDlib::TMDgetQ2min() {
if(iset < 0 ) { 
      cout << " TMDgetQ2min: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset >=101200 && iset <= 101320) return 0.0001 ;
   else if ( iset ==300001 ) return 2.4 ;
   else if ( iset ==300002 ) return 2.4 ;
   else if ( iset >=400001 && iset <= 400002) return 0.00010433  ;
   else if ( iset >=400003 && iset <= 400004) return 1.56  ;
   else if ( iset >=500001 && iset <= 500001) return 1.56  ;
   else if ( iset >=600001 && iset <= 600001) return 1.1  ;

}
double TMDlib::TMDgetQ2max() {
if(iset < 0 ) { 
      cout << " TMDgetQ2max: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset >=101000 && iset <= 101320) return 1.e6;
   else if ( iset ==300001 ) return 2.4 ;
   else if ( iset ==300002 ) return 2.4 ;
   else if ( iset >=400001 && iset <= 400002) return 160000.  ;
   else if ( iset >=400003 && iset <= 400004) return 1.e5  ;
   else if ( iset >=500001 && iset <= 500001) return 1.e5  ;
   else if ( iset >=600001 && iset <= 600001) return 13900.  ;
   else { 
      cout << " TMDgetQ2max: iset is not defined " << endl; 
      return -9999.; }

}

int TMDlib::TMDnumberPDF(string name) {

if(name == "" ) { cout << " TMDnumberPDF: name is not defined " << name << endl; }
   else if(name=="test") {
      return 101111 ;
      }
   else if(name=="test1") {
      return 101112 ;
      }
   else if(name=="test2") {
      return 101113 ;
      }
   else if(name=="test3") {
      return 101114 ;
      }
   else if(name=="inttest") {
      return 111111 ;
      }
   else if(name=="JS-2001") {
      return 101000 ;
      }
   else if(name=="ccfm-JH-set-1") {
      return 101001 ;
      }
   else if(name=="ccfm-JH-set-2") {
      return 101002 ;
      }
   else if(name=="ccfm-JH-set-3") {
      return 101003 ;
      }
   else if(name=="ccfm-setA0") {
      return 101010 ;
      }
   else if(name=="ccfm-setA0+") {
      return 101011 ;
      }
   else if(name=="ccfm-setA0-") {
      return 101012 ;
      }
   else if(name=="ccfm-setA1") {
      return 101013 ;
      }
   else if(name=="ccfm-setB0") {
      return 101020 ;
      }
   else if(name=="ccfm-setB0+") {
      return 101021 ;
      }
   else if(name=="ccfm-setB0-") {
      return 101022 ;
      }
   else if(name=="ccfm-setB1") {
      return 101023 ;
      }
   else if(name=="ccfm-JH-2013-set1") {
      return 101201 ;
      }
   else if(name == "ccfm-JH-2013-set2") {
      return 101301 ;
      }
   else if(name == "GBWlight") {
      return 200001 ;
      }
   else if(name == "GBWcharm") {
      return 200002 ;
      }
   else if(name == "SBRS-2013-TMDPDFs") {
     return 300001 ;
      }
   else if(name == "SBRS-2013-TMDPDFs-par") {
     return 300002 ;
      }
   else if(name == "KS-2013-linear") {
     return 400001 ;
      }
   else if(name == "KS-2013-non-linear") {
     return 400002 ;
      }
   else if(name == "KS-hardscale-linear") {
     return 400003 ;
      }
   else if(name == "KS-hardscale-non-linear") {
     return 400004 ;
      }
   else if(name == "EKMP") {
     return 500001 ;
      }
   else if(name == "GLLZ") {
     return 600001 ;
      }
   else { cout << " TMDnumberPDF: name is not defined " << endl; }
   
}
