#include "TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>  
#include <fstream>
using namespace std;
/* Common Block Declarations */

extern int iset, irep, imode ;
//extern int iset, irep ;
//extern int iset ;
extern string pdfpath;

extern bool first;

 void TMDlib::ccfmiPDF(int kf, double x, double p, double& uval, double& dval, double& sea, double& charm, double& bottom, double& glu)
{
    /* Initialized data */

    static int na[2] = { 51,51};


    /* Local static variables */
    static double a[153],xa[2];
    static double px[52], xx[52], q2x[52];
    static double f_grid0[2601], f_grid1[2601], f_grid2[2601], f_grid3[2601], f_grid4[2601];
    static double qscal, qg0, q2;
    static int n1min, n1max, n2min, n2max, n3min, n3max, ncall;
    static int iqqbar, iglu, ikincut, ipgg, ns_sel;

    /* Local variables */
    int irr, i, j, k, in, ip;
    int igrid;
    char txt[72], adum[1];
    double rp,rx,rq2;
    double rkms0, rkms1, rkms2, rkms3, rkms4, rkms1b, rkms2b, rkms3b, rkms4b;
    double bb, ktqt, qcdlam, scal, qtd1, ktd1;

    string filename;


    /* Function Body */
    if (abs(kf) == 2212) {
    } else {
	cout << " ccfmstfu: no valid kf = " << kf << endl;
      cout <<" ccfmstfu: only applicable for proton" << endl;
    }
    if (first) {
	n1min = 0;
	n1max = 0;
	n2min = 0;
	n2max = 0;
	n3min = 0;
	n3max = 0;
	ncall = 0;
	i = 0;
	scal = 1.;
	ipgg = 0;
	ns_sel = -1;
/*      pdfpath = getenv ("TMDlibPATH");
      if (pdfpath!="") { }
        else  {pdfpath="../data/"; }
      if (pdfpath!="") { cout << "TMDlib::ccfm_iPDF: TMDlibPATH = " <<  pdfpath << endl;}
          else { cout << " NO TMDlibPATH  set " <<endl; 
          return ;}
*/          
      if( iset < 0 ) 
        { cout << "  TMDlib:ccfmiPDF set not foud. iset = " << iset << endl;
         return ; }
        else if ( iset == 111111 ) { 
        filename=pdfpath+"ccfm-itest.dat";} 

	cout <<  "ccfmiPDF: read grid from " << filename << endl;
      string text1,text2,text3,text4,textdum;
      const char *testname = filename.c_str();
      cout << testname << endl;
      ifstream myfile (testname);
      if (myfile.is_open()) {
         myfile >> text1 >> textdum >> qg0 >> text2 >>  ikincut ;
         cout << text1 << " " << qg0 << " "<< text2 << " " << ikincut <<endl;
         myfile >> text1 >> textdum >> ipgg >> text2 >> textdum >> ns_sel ;
         cout << text1 << " " << ipgg << " "<< text2 << " " << ns_sel <<endl;
         if ( iset >= 101200 ) {
         myfile >> text1 >> textdum >> qcdlam  ;}
         else if ( iset >= 101111 && iset <= 101113 ) {
         myfile >> text1 >> textdum >> qcdlam  ;}
         else { myfile >> textdum >> textdum >> textdum >> textdum >> textdum >> textdum;}
         cout << text1 << " " << qcdlam <<endl;
         myfile >> text1 >> text2 >> text3>> text4  ;
         cout << text1 << text2 << text3 << text4 << endl;


	      for (i = 1; i <= 51; ++i) {
		   for (k = 1; k <= 51; ++k) {
                   if (!myfile.eof() ) {
                      if ( iset >= 111111 && iset <= 111113 ) {
                        myfile >>  rx >> rp >> rkms4b >>rkms3b >> rkms2b >> rkms1b 
                        >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 ; 
                        }
                        else { cout << " iset not found " << endl; }
                 //   cout << " rx " << rx << " " << rp << " rkms0 " << rkms0  << " "  << rkms1 << " " <<rkms2 << "rkms3 "<< rkms3 << " rkms4 " << rkms4 << endl;
                   } 
		   xx[i] = rx;
		   px[k] = rp;
		   f_grid0[i-1 + (k-1) * 51] = max(0.,rkms0) * scal;
		   f_grid1[i-1 + (k-1) * 51] = max(0.,rkms1) * scal;
		   f_grid2[i-1 + (k-1) * 51] = max(0.,rkms2) * scal;
		   f_grid3[i-1 + (k-1) * 51] = max(0.,rkms3) * scal;
		   f_grid4[i-1 + (k-1) * 51] = max(0.,rkms4) * scal;
		   }
	      }
	  
         cout << " end of file: ccfmstfu at "  << i << " " << k << endl;
      }
      else { cout << " error file not found " << endl;
         return ; 
      }
	in = 0;
	for (i = 1; i <= 51; ++i) {
	    ++in;
	    a[in - 1] = xx[i];
          // cout<< " counter " << in-1 << " a[i-1] = " << a[in-1] << endl;
	}
	for (i = 1; i <= 51; ++i) {
	    ++in;
	    a[in - 1] = px[i];
          // cout<< " counter " << in-1 << " a[i-1] = " << a[in-1] << endl;
	}

	first = false;
	cout <<  "  parton densities read from file unit 30 " << endl;
    }
    ++ncall;
    xa[0] = log(x);
    xa[1] = log(p);
//    cout << " ccfmiPDF: x,p: "<< x << " " << p << endl;
    if (xa[1] < px[1]) {
	++n3min;
	if (n3min < 10) {
/*            write(6,*) ' p out of range ',p,' min p ',exp(px(1)) */
/*            write(6,*) ' p out of range ',xa(1),px(1) */
	} else if (n3min == 10) {
/*            write(6,*) ' p out of range ',p,' min p ',exp(px(1)) */
/*            write(6,*) ' last message printed: min p' */
	}
	xa[1] = px[1];
    }
    if (xa[0] >= xx[51]) {
	xa[0] = xx[51] - 1e-4f;
    }
    if (xa[0] < xx[1]) {
	++n2min;
	if (n2min < 10) {
/*            write(6,*) '  x out of range ',x,' min ',exp(xx(0)) */
	} else if (n2min == 10) {
/*            write(6,*) '  x out of range ',x,' min ',exp(xx(0)) */
/*            write(6,*) ' last message printed: min x' */
	}
	xa[0] = xx[1];
    }
/* check if interpolation or grid wanted */
    igrid = 0;
    if (igrid == 1) {
	i = 0;
L20:
	++i;
	if (xa[0] > a[na[0] - 1]) {
	    cout << " x not found " << x << endl; 
	    i = na[0];
	} else {
	    if (xa[0] >= a[i - 1] && xa[0] < a[i]) {
	    } else {
		if (i <= na[0]) {
		    goto L20;
		} else {
		    cout <<  " at 20: x not found " << x << " " << a[0] << " " << a[na[0]-1]<< endl;
		}
	    }
	}
	k = 0;
L30:
	++k;
	if (xa[1] >= a[na[0] + k - 1] && xa[1] < a[na[0] + k]) {
	} else {
	    if (k <= na[1]) {
		goto L30;
	    } else {
		cout << " at 30: p not found " << p << " " << a[na[0] + k - 1] << " " << a[na[0] + na[1] - 1] << endl;
	    }
	}

	glu =   f_grid0[i-1 + (k-1) * 51] ;
	uval =  f_grid1[i-1 + (k-1) * 51] ;
	dval =  f_grid2[i-1 + (k-1) * 51] ;
	sea =   f_grid3[i-1 + (k-1) * 51] ;
	charm = f_grid4[i-1 + (k-1) * 51] ;
      
 //     cout << " grid  glu: " << " " << f_grid0[i + (k * 51)] << " uval " << uval << " i,k " << i << " " <<k <<  endl;

    } else { 
      int c3 = 2;
	glu =  Cdhfint(c3, xa, na, a, f_grid0);
	uval = Cdhfint(c3, xa, na, a, f_grid1);
	dval = Cdhfint(c3, xa, na, a, f_grid2);
	sea  = Cdhfint(c3, xa, na, a, f_grid3);
	charm  = Cdhfint(c3, xa, na, a, f_grid4);
    }
//    cout << " charm " << charm << endl;
    if (glu > 1e6) {
	cout << " new ccfmiPDF x,p,xpq" << x<< " "  << p << " "<< glu<< endl;
	cout << " i,j " << i << " " << j << endl;
    }
    return ;
} 

